/* -------------------------------------------------------------------	*/
/* Copyright (C) 2000 Robert R. Bruner.  All rights reserved.		*/
/* Contact the author at						*/
/*                    rrb@math.wayne.edu				*/
/*                    Dept of Mathematics				*/
/*                    Wayne State University				*/
/*                    Detroit, Michigan  48202				*/
/*                    USA						*/
/*									*/
/* Version 1.9.2								*/
/* -------------------------------------------------------------------- */


#include <stdio.h>
#include <stdlib.h>

#include <errors.h>
#include <storage.h>
#include <io.h>
#include <steen.h>
#include <structur.h>
#include <tensor.h>
#include <util.h>

int main(argc,argv) int argc; char *argv[];
{
int s,s0,g0,s1,		/* Map has degree s.  Check generators  g0 in 	*/
			/*  filts s0 up to and including s1		*/
    **done,		/* done[s0][g0] = 1 iff gen g0 in filt s0	*/
			/*  is already computed				*/
    t,imlen,i,j;	/* indices 					*/


Tensor_shape *Dom_shape; /* easy way to keep track of gens and degrees	*/

FILE *Def,		/* Map Definition file				*/
     *Map;		/* Map file					*/

char Domain[256],
     Codomain[256],
     MapDir[256];

/* -------------- check calling sequence -----------------------------  */
if (argc != 2)
{
  printf("\nUsage: checkmap s");
  printf("\nChecks for unmapped generators in filtrations up to s\n");
  return(1);
}

/* ---------- New code from new startmap ----------------------	*/

/*  get arg s1 and  read map definition file				*/

sscanf(argv[1],"%d",&s1);

if ((Def = fopen("Def","r")) == NULL)
   terminate("\nCannot open map definition file Def", BAD_MAP);

fscanf(Def,"%d %d %s %s %s %d",&s,&t,Domain,Codomain,MapDir,&imlen);

if (s1 < s) return(0);				/* Nothing to do	*/

/* ------------------------------------------------------------------   */
/* get shape								*/

Dom_shape = fread_shape("../Shape",s1);

done = (int **) malloc((s1 + 1)* sizeof(int *));
for (i=s; i <= s1; i++) 
 {  done[i] = (int *) malloc(Dom_shape->numgen[i] * sizeof(int));
    for (j=0; j < Dom_shape->numgen[i]; j++) done[i][j] = 0;
 }

/* ------------------------------------------------------------------   */
/* note which gens are mapped					*/

if ((Map = fopen("Map","r")) == NULL)
   terminate("Cannot open Map file",BAD_MAP);

while (EOF != fscanf(Map,"%d %d",&s0,&g0))
{  
   if (s0 <= s1) done[s0][g0] = 1;
   skip_Element(Map);
}

fclose(Map);


/* ------------------------------------------------------------------   */
/* Now report what has not been mapped 					*/

for (i=s; i <= s1; i++) 
  for (j=0; j < Dom_shape->numgen[i]; j++) 
   if (done[i][j] == 0) printf("%4d %4d\n",i,j);

return(0);
}
