/* -------------------------------------------------------------------	*/
/* Copyright (C) 2000 Robert R. Bruner.  All rights reserved.		*/
/* Contact the author at						*/
/*                    rrb@math.wayne.edu				*/
/*                    Dept of Mathematics				*/
/*                    Wayne State University				*/
/*                    Detroit, Michigan  48202				*/
/*                    USA						*/
/*									*/
/* Version 1.6								*/
/* -------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>

#include <structur.h>
#include <io.h>
#include <storage.h>
#include <util.h>


int main(argc,argv) int argc; char *argv[];
{
Element *e,*f;
int i,j,k,hdr_num,prefix_num,done,nelts,num;
int count;
char type, number='n';
FILE *in,*out;

if ((argc != 6) && ((argc != 7) || (argv[6][1] != '\0') ||
   ((argv[6][0] != 'c') &&
    (argv[6][0] != 'n') &&
    (argv[6][0] != 's') &&
    (argv[6][0] != 'x') &&
    (argv[6][0] != 'i') &&
    (argv[6][0] != 'b') )))
{ fprintf(stderr,
   "\nUsage: convert infile outfile hdr_size prefix_size block_size [type]");
  fprintf(stderr,
   "\nwhere type, if included, is one of c, n, x, s, i, or b (default = c)");
  fprintf(stderr,
   "\nTypes are c=condensed, x=hex, s=sequence numbers, i=Milnor basis,");
  fprintf(stderr,
   "\nb=binary, n=numbered and Milnor basis. \n\n");
    exit(1);
  }

if (argc == 7) type = argv[6][0]; else type = 'c'; 
if (type == 'n') { number = 'y'; type = 'i';}

sscanf(argv[3],"%d",&hdr_num);
sscanf(argv[4],"%d",&prefix_num);
sscanf(argv[5],"%d",&nelts);

if ((in = fopen(argv[1],"r")) == NULL) 
  { printf("\nError opening %s\n",argv[1]);
    exit(1);
  }

if ((out = fopen(argv[2],"w")) == NULL) 
  { printf("\nError opening %s\n",argv[2]);
    exit(1);
  }

for (i=0; i<hdr_num; i++) 
   { fscanf(in,"%d",&j);
     fprintf(out,"%10d ",j);
   }

fprintf(out,"\n");

done = 0;
count = 0;
while (!done) {

  for (i=0; (! done ) && (i<prefix_num); i++)
   { done = done || (EOF == fscanf(in,"%d",&j));
     if (!done) 
     {
        if ((number == 'y') && (i==0)) fprintf(out,"\n%d : ",count++);
	fprintf(out,"%d ",j);
     }
   }

if (! done) 
 { fprintf(out,"\n");

   for (j=0; j < nelts; j++)
    { e = read_Element(in);
      write_Element(out,e,type);
      fprintf(out,"\n");
    }
 }
}

fclose(in);
fclose(out);

return 0;
}
