/* -------------------------------------------------------------------	*/
/* Copyright (C) 2000 Robert R. Bruner.  All rights reserved.		*/
/* Contact the author at						*/
/*                    rrb@math.wayne.edu				*/
/*                    Dept of Mathematics				*/
/*                    Wayne State University				*/
/*                    Detroit, Michigan  48202				*/
/*                    USA						*/
/*									*/
/* Version 1.6								*/
/* -------------------------------------------------------------------- */


#include <stdio.h>
#include <stdlib.h>

#include <errors.h>
#include <io.h>

typedef struct node { int numgen;
		      int *deg;
		      struct node *next; } node;

int main(argc,argv) int argc; char *argv[];
{
int   s,maxs,i,deg;
FILE *Diff, *shape;
node *list, *n, **last;
char filename[20];

/* -------------- check calling sequence -----------------------------  */
if ((argc != 1) && (argc != 2))
{
  printf("\nUsage: makeshape [s] \n");
  printf(" creates shape file using all Diff files if s is omitted,\n");
  printf(" stops at Diff.s, if s is given.\n");
  exit(1);
 }

if (argc == 2)
   sscanf(argv[1],"%d",&maxs);
else maxs = -1;
/* -------------------------------------------------------------------- */ 

s=0;
last = &list;
sprintf(filename,"Diff.%d",s);

while (((Diff = fopen(filename,"r")) != NULL) &&
	((maxs < 0) || (s <= maxs)))
{
   *last = n = (node *) malloc(sizeof(node));
   last = &(n->next);
   n->next = NULL;

   fscanf(Diff,"%d %d",&(n->numgen),&deg);
   n->deg = (int *) malloc(n->numgen * sizeof(int *));

   for (i=0; i < n->numgen; i++)
     { fscanf(Diff,"%d",&n->deg[i]);
       skip_Element(Diff);
     }
   fclose(Diff);

   sprintf(filename,"Diff.%d",++s);
}

if ((shape = fopen("Shape","w")) == NULL)
  terminate("\nError opening Shape\n",13);

fprintf(shape,"%d\n",--s);
for (n=list; n != NULL; n = n->next)
   fprintf(shape,"%d ",n->numgen);
for (n=list; n != NULL; n = n->next)
  { fprintf(shape,"\n");
    for (i=0; i < n->numgen; i++)
       fprintf(shape,"%d ",n->deg[i]);
  }
fprintf(shape,"\n");
fclose(shape);
return 0;
}

