/* -------------------------------------------------------------------	*/
/* Copyright (C) 2000 Robert R. Bruner.  All rights reserved.		*/
/* Contact the author at						*/
/*                    rrb@math.wayne.edu				*/
/*                    Dept of Mathematics				*/
/*                    Wayne State University				*/
/*                    Detroit, Michigan  48202				*/
/*                    USA						*/
/*									*/
/* Version 1.5								*/
/* Version 1.9.2 Added dimA declaration, inexplicably left out before, 	*/
/*               and removed d(k,n), not used for A(2).                	*/
/* -------------------------------------------------------------------- */

#ifndef N_ALG
#define N_ALG 3
#endif


#ifndef STEEN_DONE

#include <structur.h>

typedef int Internal_Op[N_ALG];

/* Routines to define the subalgebra A(2) generated by Sq^1, Sq^2 and   */
/* Sq^4.   Some parts can clearly be generalized to A(n), but in the    */
/* interest of speed, this version also has a somewhat ad hoc aspect.   */

extern  unsigned      dimA(/* int n */);

extern         int    degree( /* Internal_Op Op */ );
extern  void          fprint_op(/* FILE *fp; Internal_Op Op */);
extern  void          print_op (/*Internal_Op Op*/);
extern  int           first_op (/*Internal_Op Op,int deg*/);
extern  int           next_op(/*Internal_Op Op, int seqno*/);
extern  int           advance_op (/*Internal_Op Op*/);
extern  int           adv_op (/*Internal_Op Op,int k*/);
extern  unsigned int  Seqno (/*Internal_Op Op*/);
extern  int           mult (/*Internal_Op R,Internal_Op S,TERM *x*/);
extern  int           first_Coproduct(/* Internal_Op Op,Op1,Op2 */);
extern  int           next_Coproduct(/* Internal_Op Op,Op1,Op2 */);
#define STEEN_DONE


#endif
